#include <bits/stdc++.h>

#define int int64_t

const int N = 1e6 + 1;

std::vector<int> dp(N);

signed main() {
  std::ios::sync_with_stdio(false);
  std::cin.tie(0);
  int tt;
  std::cin >> tt;
  std::vector<int> ans(tt + 1);
  std::vector<int> x(tt + 1);
  std::vector<std::pair<int, int>> q;
  for(int i = 1; i <= tt; i++) {
    std::cin >> x[i];
    q.push_back({x[i], i});
  }
  std::sort(q.begin(), q.end());
  dp[1] = 1;
  int j = 2;
  std::set<int> st;
  st.insert(1);
  for(auto [x, i] : q) {
    while(j <= x) {
      if(j < 10) {
        dp[j] = j;
      }
      else {
        dp[j] = dp[j / 10] * (j % 10);
      }
      st.insert(dp[j]);
      j += 1;
    }
    ans[i] = st.size();
  }
  for(int i = 1; i <= tt; i++) {
    std::cout << ans[i] << " ";
  }
}